<?
	include('security.php');
	include('config.php');
?>
<html>
<title>SVN Repository Admin</title>
<body>
<h1>SVN Repository Admin</h1>

Hint: the virtual repository "admin" reflects global settings.<p>

Hint 2: if you don't see anything here, you are probably not an admin.<p>

<?
	//Read access file
	$acc=file($ACCESS);
	//scan lines
	reset($acc);
	$grp="";
	$admin=array();
	$acl=array();
	$listing=array();
	$groups=array();
	while(list($k,$ln)=each($acc)){
		$ln=trim($ln);
		//admin array:
		if(substr($ln,0,2)=="#@"){
			$a=explode("=",substr($ln,2));
			$admin[trim($a[0])]=explode(" ",trim($a[1]));
			continue;
		}
		//web listing
		if(substr($ln,0,2)=="#$"){
			$listing[trim(substr($ln,2))]=1;
			continue;
		}
		//ignore empty/comment lines
		if($ln=="" || substr($ln,0,1)=="#")continue;
		//groups
		if(preg_match("/^\[(.*)\]$/i",$ln,$ma)){
			$grp=$ma[1];
			$a=explode(":",$grp);
			if(isset($a[1])){
				$rep=$a[0];
				$path=$a[1];
			}else{
				$rep="admin";
				$path=$a[0];
			}
			continue;
		}
		//normal patterns
		if($grp=="")
			die("Invalid file format, giving up. Fix it by hand bozo!");
		$a=explode("=",$ln);
		if($path=="groups"){
			$groups[trim($a[0])]=explode(" ",trim($a[1]));
		}else{
			$acl[$rep][$path][trim($a[0])]=trim($a[1]);
		}
	}
	$isadmin=isset($admin["admin"])&&in_array($user,$admin["admin"]);
	
	//scan directory
	$dir=array();
	$d=dir($SVNDIR);
	while(($e=$d->read()) !== false)
		if($e!="." && $e !="..")$dir[]=$e;
		
	//scan password file
	$users=array();
	$us=file($PASSWD);
	reset($us);
	while(list($k,$ln)=each($us)){
		if($ln!=""){
			$u=explode(":",$ln);
			$users[]=$u[0];
		}
	}
	
	//Handle User change requests
	if($isadmin){
		unset($u);
		if(isset($HTTP_POST_VARS["adduser"])){
			$u=$HTTP_POST_VARS["user"];
			if(in_array($u,$users)){
				print("<font color=\"red\">Cannot create user: user $u already exists!</font><p>");
				unset($u);
			}else $users[]=$u;
		}
		if(isset($HTTP_POST_VARS["resetuser"])){
			$u=$HTTP_POST_VARS["user"];
			if(!in_array($u,$users)){
				print("<font color=\"red\">Cannot reset user: user $u doesn't exist!</font><p>");
				unset($u);
			}
		}
		if(isset($u)){
			exec("$HTPASSWD -bm ".escapeshellarg($PASSWD)." ".
				escapeshellarg($u)." ".
				escapeshellarg($HTTP_POST_VARS["passwd"]),$out,$rc);
			if($rc){
				print("<font color=\"red\">Error while setting password of $u.<br>\n");
			}else{
				print("<font color=\"green\">Password of $u has been set.<br>\n");
			}
			reset($out);
			while(list($k,$v)=each($out)){
				print(htmlspecialchars($v)."<br>\n");
			}
			print("</font>");
		}
	}
	
	//Handle Group Changes
	if(isset($HTTP_POST_VARS["grpupdate"]) || isset($HTTP_POST_VARS["grpnew"])){
		if(isset($adm4))unset($adm4);
		if($isadmin)$adm4[]="";
		reset($dir);
		while(list($k,$m)=each($dir)){
			if($isadmin || (isset($admin[$m])&&in_array($user,$admin[$m])))$adm4[]=$m;
		}
		if(isset($adm4)&&isset($HTTP_POST_VARS["grpnew"])&&in_array($HTTP_POST_VARS["base"],$adm4)){
			//base, gname, iuser
			if($HTTP_POST_VARS["base"]=="")$gn="";else $gn=$HTTP_POST_VARS["base"];
			if(preg_match("/^[a-z0-9]*$/",$HTTP_POST_VARS["gname"])){
				$CHANGED=1;
				if($gn!="")$gn.="_".$HTTP_POST_VARS["gname"];
				else $gn=$HTTP_POST_VARS["gname"];
				if($gn=="" || !in_array($HTTP_POST_VARS["iuser"],$users)){
					print("<font color=\"red\">Group name must contain characters and initial user must exist!</font>\n");
				}else{
					$CHANGED=1;
					$groups[$gn]=array($HTTP_POST_VARS["iuser"]);
				}
			}else{
				print("<font color=\"red\">Group name must contain lower case letters and digits only!</font>\n");
			}
		}
		if(isset($adm4)&&isset($HTTP_POST_VARS["grpupdate"])&&
		   ($isadmin||in_array($HTTP_POST_VARS["base"],$adm4))){
			$gn=$HTTP_POST_VARS["base"];
			if(isset($HTTP_POST_VARS["gname"])&&$HTTP_POST_VARS["gname"]!="")
				$gn.="_".$HTTP_POST_VARS["gname"];
			if(!isset($groups[$gn])){
				print("<font color=\"red\">Group $gn does not exist!</font>\n");
			}else{
				$CHANGED=1;
				if(isset($HTTP_POST_VARS["del"])){
					$del=$HTTP_POST_VARS["del"];
					$g=$groups[$gn];
					reset($g);
					//if all users are deleted from the group, it remains completely deleted:
					unset($groups[$gn]);
					while(list($k,$u)=each($g)){
						if(!in_array($u,$del))$groups[$gn][]=$u;
					}
				}
				if(isset($HTTP_POST_VARS["new"])){
					if(in_array($HTTP_POST_VARS["new"],$users))
						$groups[$gn][]=$HTTP_POST_VARS["new"];
				}
			}
		}
	}
	
	//Handle Admin changes
	if(isset($HTTP_POST_VARS["updadmin"])){
		if(isset($adm4))unset($adm4);
		reset($dir);
		while(list($k,$m)=each($dir)){
			if($isadmin || (isset($admin[$m])&&in_array($user,$admin[$m])))$adm4[]=$m;
		}
		$rep=$HTTP_POST_VARS["rep"];
		if(in_array($rep,$dir)&&in_array($rep,$adm4)){
			$CHANGED=1;
			if(isset($admin[$rep])){
				$adm=$admin[$rep];
				unset($admin[$rep]);
			}else $adm=array();
			if(isset($HTTP_POST_VARS["del"]))$del=$HTTP_POST_VARS["del"];
			else $del=array();
			reset($adm);
			while(list($k,$u)=each($adm))
				if(!in_array($u,$del)&&in_array($u,$users))$admin[$rep][]=$u;
				
			if(isset($HTTP_POST_VARS["add"]))$u=$HTTP_POST_VARS["add"];
			else $u=".";
			if($u!="."&&in_array($u,$users))
				$admin[$rep][]=$u;
		}else{
			print("<font color=\"red\">You are not admin for $rep!</font>");
		}
	}
	
	//Handle ACL Changes		
	if(isset($HTTP_POST_VARS["updacl"])){
		$rep=$HTTP_POST_VARS["rep"];
		$path=$HTTP_POST_VARS["dir"];
		if(isset($adm4))unset($adm4);
		reset($dir);
		while(list($k,$m)=each($dir)){
			if($isadmin || (isset($admin[$m])&&in_array($user,$admin[$m])))$adm4[]=$m;
		}
		if(in_array($rep,$adm4)&&isset($acl[$rep][$path])){
			$racl=$acl[$rep][$path];
			unset($acl[$rep][$path]);
			reset($racl);
			$CHANGED=1;
			while(list($u,$r)=each($racl)){
				if(in_array($u,$users)|| $u == "*" ||
				   (substr($u,0,1)=="@" && array_key_exists(substr($u,1),$groups))){
				   	if(isset($HTTP_POST_VARS["r_".$u])){
						$nr=$HTTP_POST_VARS["r_".$u];
						if(in_array($nr,array("r","rw","rev"))){
							if($nr=="rev")$nr="";
							$acl[$rep][$path][$u]=$nr;
						} //else do not place a del in $acl
					}else{
						//no change, use old value:
						$acl[$rep][$path][$u]=$r;
					}
				}
			}
			if(isset($HTTP_POST_VARS["new"])&&$HTTP_POST_VARS["new"]!="."){
				$u=$HTTP_POST_VARS["new"];
				$r=$HTTP_POST_VARS["rnew"];
				if($u=="*"||in_array($u,$users)||
				   (substr($u,0,1)=="@" && array_key_exists(substr($u,1),$groups))){
				   	if(in_array($r,array("r","rw","rev"))){
						if($r=="rev")$r="";
						$acl[$rep][$path][$u]=$r;
					}
				}
			}
		}
	}
	
	if(isset($HTTP_POST_VARS["newacl"])){
		$rep=$HTTP_POST_VARS["rep"];
		$path=$HTTP_POST_VARS["dir"];
		if(isset($adm4))unset($adm4);
		reset($dir);
		while(list($k,$m)=each($dir)){
			if($isadmin || (isset($admin[$m])&&in_array($user,$admin[$m])))$adm4[]=$m;
		}
		if(in_array($rep,$adm4)){
			//sanity check path:
			$xpath=explode("/",$path);
			if(in_array("..",$xpath)){
				print("<font color=\"red\">Path must not contain \"..\"!</font>");
			}else{
				//further sanitize path:
				reset($xpath);
				$path="";
				while(list($k,$p)=each($xpath))
					if($p!=""&&$p!=".")
						$path.="/".$p;
				if($path=="")$path="/";
				//set acl
				$u=$HTTP_POST_VARS["new"];
				$r=$HTTP_POST_VARS["rnew"];
				if(in_array($u,$users)||$u=="*"||
				   (substr($u,0,1)=="@" && array_key_exists(substr($u,1),$groups))){
				   	if(in_array($r,array("r","rw","rev"))){
						if($r=="rev")$r="";
				   		$acl[$rep][$path][$u]=$r;
						$CHANGED=1;
					}
				}
			}
		}
	}
	
	//Save New Settings
	if(isset($CHANGED)){
		$fd=fopen($ACCESS.".new","x");
		if($fd===false){
			print("<font color=\"red\">Cannot write new access rules.</font>");
		}else{
			fputs($fd,"# DO NOT MODIFY THIS FILE, IT IS GENERATED AUTOMATICALLY!\n");
			fputs($fd,"#\n#Administrators:\n");
			#put admins
			ksort($admin);
			reset($admin);
			while(list($rep,$adm)=each($admin)){
				asort($adm);
				reset($adm);
				$as="";
				while(list($k,$a)=each($adm)){
					if(in_array($a,$users))$as.=" ".$a;
				}
				if($as!="")
					fputs($fd,"#@$rep =$as\n");
			}
			#put groups
			ksort($groups);
			reset($groups);
			fputs($fd,"\n[groups]\n");
			while(list($grp,$usr)=each($groups)){
				asort($usr);
				reset($usr);
				$as="";
				while(list($k,$u)=each($usr)){
					if(in_array($u,$users))$as.=" ".$u;
				}
				if($as!="")
					fputs($fd,"$grp =$as\n");
			}
			#put repositories
			ksort($acl);
			reset($acl);
			while(list($rep,$racl)=each($acl)){
				//check that rep is valid and not admin (admin comes later)
				if(in_array($rep,$dir) && $rep != "admin"){
					ksort($racl);
					reset($racl);
					while(list($path,$pacl)=each($racl)){
						krsort($pacl);
						reset($pacl);
						fputs($fd,"\n[$rep:$path]\n");
						while(list($u,$r)=each($pacl)){
							if(in_array($u,$users)||$u=="*"||
							   (substr($u,0,1)=="@"&&array_key_exists(substr($u,1),$groups))){
								fputs($fd,"$u = $r\n");
							}
						}
					}
				}
			}
			//put admin area
			if(isset($acl["admin"])){
				$racl=$acl["admin"];
				ksort($racl);
				reset($racl);
				while(list($path,$pacl)=each($racl)){
					krsort($pacl);
					reset($pacl);
					fputs($fd,"\n[$path]\n");
					while(list($u,$r)=each($pacl)){
						if(in_array($u,$users)||$u=="*"||
							(substr($u,0,1)=="@"&&array_key_exists(substr($u,1),$groups))){
							fputs($fd,"$u = $r\n");
						}
					}
				}
			}
			//close and move
			fclose($fd);
			exec("mv -f ".escapeshellarg($ACCESS.".new")." ".escapeshellarg($ACCESS));
		}
	}
		
	//render repositories
	asort($dir);
	reset($dir);
	while(list($k,$rep)=each($dir)){
		if((isset($admin[$rep])&&in_array($user,$admin[$rep]))||$isadmin){
			print("<hr>\n<h2>Repository: $rep</h2>\n");
			
			//Admins of this repository
			print("<b>Admins:</b><a name=\"admin_$rep\"><br>\n");
			print("<form action=\"svnadmin.php#admin_$rep\" method=\"POST\">\n");
			print("<input type=\"hidden\" name=\"rep\" value=\"$rep\">\n");
			print("<table frame=\"1\" border=\"1\">\n");
			print("<tr><td><b>Del?</b></td><td><b>User</b></td></tr>\n");
			if(isset($admin[$rep])){
				$adm=$admin[$rep];
				reset($adm);
				while(list($ka,$a)=each($adm)){
					print("<tr><td><input type=\"checkbox\" name=\"del[]\" value=\"$a\"></td><td>$a</td></tr>\n");
				}
			}
			print("<tr><td><b>Add:</b></td><td><select name=\"add\"><option value=\".\">None\n");
			asort($users);
			reset($users);
			while(list($ku,$u)=each($users)){
				print("<option value=\"$u\">$u\n");
			}
			print("</select></td></tr>\n");
			print("</table><p>\n");
			print("<input type=\"submit\" name=\"updadmin\" value=\"Update\">\n");
			print("</form>\n");
			
			//ACL of this repository
			if(isset($acl[$rep])){
				$racl=$acl[$rep];
				ksort($racl);
				reset($racl);
				while(list($d,$dacl)=each($racl)){
					$dx="acl_".urlencode($rep)."_".urlencode($d);
					print("<form action=\"svnadmin.php#$dx\" method=\"POST\">\n");
					print("<b>Path: $d</b><a name=\"$dx\"><br>\n");
					print("<input type=\"hidden\" name=\"rep\" value=\"$rep\">\n");
					print("<input type=\"hidden\" name=\"dir\" value=\"$d\">\n");
					print("<table frame=\"1\" border=\"1\">\n");
					print("<tr><td><b>User/@Group</b></td><td><b>Rights</b></td></tr>\n");
					ksort($dacl);
					reset($dacl);
					while(list($u,$r)=each($dacl)){
						print("<tr><td>");
						if($u=="*")print("Everybody *");else
						if(substr($u,0,1)=="@")print("Group $u");
						else print($u);
						print("</td><td><select name=\"r_$u\">");
						print("<option value=\"del\">Delete record\n");
						print("<option value=\"r\"".($r=="r"?" selected":"").">Read Only\n");
						print("<option value=\"rw\"".($r=="rw"?" selected":"").">Read/Write\n");
						print("<option value=\"rev\"".($r==""?" selected":"").">Revoke All\n");
						print("</select></td></tr>\n");
					}
					print("<tr><td>Add: <select name=\"new\"><option value=\".\">None\n");
					asort($users);
					reset($users);
					while(list($ku,$u)=each($users)){
						print("<option value=\"$u\">$u\n");
					}
					ksort($groups);
					reset($groups);
					while(list($ku,$u)=each($groups)){
						print("<option value=\"@$ku\">Group @$ku\n");
					}
					print("<option value=\"*\">Everybody *\n");
					print("</select></td><td><select name=\"rnew\">");
					print("<option value=\"del\">Delete record\n");
					print("<option value=\"r\" selected>Read Only\n");
					print("<option value=\"rw\">Read/Write\n");
					print("<option value=\"rev\">Revoke All\n");
					print("</select></td></tr>\n");
					print("</table><p>\n");
					print("<input type=\"submit\" name=\"updacl\" value=\"Update\">\n");
					print("</form><p>\n");
				}
			}
			//add dirs
			print("<b>Add Directory:</b><a name=\"newacl_$rep\"><br>\n");
			print("<form action=\"svnadmin.php#newacl_$rep\" method=\"POST\">\n");
			print("<input type=\"hidden\" name=\"rep\" value=\"$rep\">\n");
			print("<table frame=\"1\" border=\"1\">\n");
			print("<tr><td>New Path:</td><td><input type=\"text\" name=\"dir\"></td></tr>\n");
			print("<tr><td>Initial user:</td><td><select name=\"new\">");
			asort($users);
			reset($users);
			while(list($ku,$u)=each($users)){
				print("<option value=\"$u\">$u\n");
			}
			ksort($groups);
			reset($groups);
			while(list($ku,$u)=each($groups)){
				print("<option value=\"@$ku\">Group @$ku\n");
			}
			print("<option value=\"*\">Everybody *\n");
			print("</select></td></tr>\n");
			print("<tr><td>Initial Rights:</td><td><select name=\"rnew\">");
			print("<option value=\"r\" selected>Read Only\n");
			print("<option value=\"rw\">Read/Write\n");
			print("<option value=\"rev\">Revoke All\n");
			print("</select></td></tr>\n");
			print("</table><p>\n");
			print("<input type=\"submit\" name=\"newacl\" value=\"Add\">\n");
			print("</form><p>\n");
		}
	}
	
	//render groups
	ksort($groups);
	reset($groups);
	print("<hr>\n<h2>User Groups</h2>\n");
	while(list($grp,$usrs)=each($groups)){
		$gname=explode("_",$grp);
		if($isadmin || (isset($admin[$gname[0]]) && in_array($user,$admin[$gname[0]]))){
			print("<a name=\"group_$grp\"><b>Group: $grp</b><br>\n");
			print("<form action=\"svnadmin.php#group_$grp\" method=\"POST\">\n");
			print("<input type=\"hidden\" name=\"base\" value=\"$gname[0]\">");
			print("<input type=\"hidden\" name=\"gname\" value=\"".(isset($gname[1])?$gname[1]:"")."\">");
			print("<table frame=\"1\" border=\"1\">\n");
			print("<tr><td><b>Del?</b></td><td><b>User</b></td></tr>\n");
			asort($usrs);
			reset($usrs);
			while(list($ku,$u)=each($usrs)){
				print("<tr><td><input type=\"checkbox\" name=\"del[]\" value=\"$u\"></td><td>$u</td></tr>\n");
			}
			print("<tr><td><b>Add:</b></td><td><select name=\"new\"><option value=\".\">None\n");
			asort($users);
			reset($users);
			while(list($ku,$u)=each($users)){
				print("<option value=\"$u\">$u\n");
			}
			print("</select></td></tr>\n");
			print("</table><br>\n");
			print("<input type=\"submit\" name=\"grpupdate\" value=\"Update\">\n");
			print("</form><p>\n");
		}
	}
	if(isset($adm4))unset($adm4);
	if($isadmin)$adm4[]="";
	reset($dir);
	while(list($k,$m)=each($dir)){
		if($isadmin || (isset($admin[$m])&&in_array($user,$admin[$m])))$adm4[]=$m;
	}
	if(isset($adm4)){
		print("<a name=\"newgroup\"><b>Create New Group:</b><br>\n");
		print("<form action=\"svnadmin.php#newgroup\" method=\"POST\">\n");
		print("<table frame=\"1\" border=\"1\">\n");
		print("<tr><td><b>New Group Base:</b></td><td><select name=\"base\">");
		reset($adm4);
		while(list($k,$m)=each($adm4))
			print("<option value=\"$m\">$m");
		print("</td></tr>\n");
		print("<tr><td><b>New Group Name:</b></td><td><input type=\"text\" name=\"gname\"></td></tr>\n");
		print("<tr><td><b>Initial User:</b></td><td><select name=\"iuser\">");
		asort($users);
		reset($users);
		while(list($ku,$u)=each($users)){
			print("<option value=\"$u\">$u\n");
		}
		print("</select></td></tr>\n");
		print("</table><br>\n");
		print("<input type=\"submit\" name=\"grpnew\" value=\"Add\">\n");
		print("</form><p>\n");
	}
	
	//render users
	if($isadmin){
		print("<hr>\n<h1>Users</h1>\n");
		
		print("<form action=\"svnadmin.php\" method=\"POST\">\n");
		print("<b>Reset Password:</b> <select name=\"user\">");
		asort($users);
		reset($users);
		while(list($ku,$u)=each($users)){
			print("<option value=\"$u\">$u\n");
		}
		print("</select><input type=\"password\" name=\"passwd\">");
		print("<input type=\"submit\" name=\"resetuser\" value=\"Reset\"></form><p>\n");
		
		print("<form action=\"svnadmin.php\" method=\"POST\">\n");
		print("<b>New User:</b> <input type=\"text\" name=\"user\"> Password:");
		print("<input type=\"password\" name=\"passwd\">");
		print("<input type=\"submit\" name=\"adduser\" value=\"Add\"></form><p>\n");
	}
		
?>

</body>
</html>